# AddyLambda

The purpose of this gem, is to make common functionality for Lambdas be available across all of our Lambda implementaitons.

Things like:

- calling API endpoints
- Posting to slack
- Getting a JWT token
- Sending an email
- etc ..

This would allow us to be consistent with our approach to those common functions without duplicating code.

## Installation

Add this line to your application's Gemfile:

```ruby
gem 'addy_lambda'
```

And then execute:

    $ bundle install

Or install it yourself as:

    $ gem install addy_lambda

## Publishing a new version

- Make your changes
- Bump the version in `lib/addy_lambda/version.rb`
- Build using `gem build addy_lambda.gemspec`
- Run (this needs to happen once) `curl -u addydev https://rubygems.org/api/v1/api_key.yaml > ~/.gem/credentials; chmod 0600 ~/.gem/credentials`
- gem push addy_lambda-<version>.gem

## Usage

Run the tests:

```
ruby "/home/cabox/workspace/addy_lambda/test/addy_lambda_test.rb"
```

For local development:

```
rake build
gem install pkg/addy_lambda-<version>.gem
```

Example usage:

```
require 'addy_lambda'
require 'aws-sdk-ssm'

ssm_client = Aws::SSM::Client.new
test= AddyLambda::AWS::get_ssm_value(ssm_client, '/dev/test')

puts(test)
```

## Development

After checking out the repo, run `bin/setup` to install dependencies. Then, run `bundle exec ruby test/test_helper.rb` to run the tests. You can also run `bin/console` for an interactive prompt that will allow you to experiment.

To install this gem onto your local machine, run `bundle exec rake install`. To release a new version, update the version number in `version.rb`, and then run `bundle exec rake release`, which will create a git tag for the version, push git commits and tags, and push the `.gem` file to [rubygems.org](https://rubygems.org).

## Contributing

Bug reports and pull requests are welcome on GitHub at https://github.com/[USERNAME]/addy_lambda. This project is intended to be a safe, welcoming space for collaboration, and contributors are expected to adhere to the [code of conduct](https://github.com/[USERNAME]/addy_lambda/blob/master/CODE_OF_CONDUCT.md).

## License

The gem is available as open source under the terms of the [MIT License](https://opensource.org/licenses/MIT).

## Code of Conduct

Everyone interacting in the AddyLambda project's codebases, issue trackers, chat rooms and mailing lists is expected to follow the [code of conduct](https://github.com/[USERNAME]/addy_lambda/blob/master/CODE_OF_CONDUCT.md).
